-- MySQL Script generated by MySQL Workbench
-- 01/02/15 14:46:43
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema CFStagingArea
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `CFStagingArea` ;

-- -----------------------------------------------------
-- Schema CFStagingArea
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `CFStagingArea` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;
-- -----------------------------------------------------
-- Schema ClubFitnessDW
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `ClubFitnessDW` ;

-- -----------------------------------------------------
-- Schema ClubFitnessDW
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `ClubFitnessDW` ;
USE `CFStagingArea` ;

-- -----------------------------------------------------
-- Table `CFStagingArea`.`Clubs`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Clubs` (
  `CodiClub` VARCHAR(255) NOT NULL,
  `ClubName` VARCHAR(255) NULL DEFAULT NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`CodiClub`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE UNIQUE INDEX `CodiClub_UNIQUE` ON `CFStagingArea`.`Clubs` (`CodiClub` ASC);


-- -----------------------------------------------------
-- Table `CFStagingArea`.`Members`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Members` (
  `Club_name` VARCHAR(255) NOT NULL,
  `Member_number` INT NOT NULL,
  `Member_name` VARCHAR(255) NULL DEFAULT NULL,
  `Profession` VARCHAR(255) NULL,
  `Address` VARCHAR(255) NULL,
  `City` VARCHAR(255) NULL DEFAULT NULL,
  `Region` VARCHAR(255) NULL,
  `PostalCode` VARCHAR(255) NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  `Phone` VARCHAR(255) NULL,
  `Fax` VARCHAR(255) NULL,
  `Registration_data` VARCHAR(255) NULL DEFAULT NULL,
  `Sex` CHAR(1) NULL DEFAULT NULL,
  `Marital_status` VARCHAR(255) NULL DEFAULT NULL,
  `Birth_date` VARCHAR(255) NULL DEFAULT NULL,
  `Monthly_tennis_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_padel_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_personal_trainer_fee` CHAR(1) NULL DEFAULT NULL,
  `Since_when_is_debtor` VARCHAR(255) NULL DEFAULT NULL,
  `Registration_web` CHAR(1) NULL,
  PRIMARY KEY (`Club_name`, `Member_number`),
  CONSTRAINT `Club_name`
    FOREIGN KEY (`Club_name`)
    REFERENCES `CFStagingArea`.`Clubs` (`CodiClub`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE INDEX `Club_name_idx` ON `CFStagingArea`.`Members` (`Club_name` ASC);


-- -----------------------------------------------------
-- Table `CFStagingArea`.`Monthly_fees`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Monthly_fees` (
  `Code` VARCHAR(255) NOT NULL,
  `Description` VARCHAR(255) NULL DEFAULT NULL,
  `Price` DECIMAL(5,2) NULL DEFAULT NULL,
  `Fee_type` VARCHAR(255) NULL DEFAULT NULL,
  `Obligatory/optional` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`Code`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `CFStagingArea`.`Access`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Access` (
  `TempsAcces` VARCHAR(255) NULL,
  `Member_number` INT NULL,
  `Club` VARCHAR(255) NULL)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

USE `ClubFitnessDW` ;

-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Clubs`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Clubs` (
  `CodiClub` VARCHAR(255) NOT NULL,
  `ClubName` VARCHAR(255) NULL DEFAULT NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`CodiClub`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Membres`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Membres` (
  `Club_name` VARCHAR(255) NULL,
  `Member_number` INT NULL,
  `Member_name` VARCHAR(255) NULL DEFAULT NULL,
  `City` VARCHAR(255) NULL DEFAULT NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  `Registration_data` DATE NULL DEFAULT NULL,
  `Sex` CHAR(1) NULL DEFAULT NULL,
  `Marital_status` VARCHAR(255) NULL DEFAULT NULL,
  `Birth_date` DATE NULL DEFAULT NULL,
  `Age` INT NULL,
  `Group_age` VARCHAR(255) NULL DEFAULT NULL,
  `Monthly_tennis_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_padel_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_personal_trainer_fee` CHAR(1) NULL DEFAULT NULL,
  `Since_when_is_debtor` DATE NULL DEFAULT NULL,
  CONSTRAINT `Club_FK`
    FOREIGN KEY (`Club_name`)
    REFERENCES `ClubFitnessDW`.`Clubs` (`CodiClub`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Quotes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Quotes` (
  `Codi` VARCHAR(255) NOT NULL,
  `Description` VARCHAR(255) NULL,
  `Price` DECIMAL(5,2) NULL DEFAULT NULL,
  `Fee_type` VARCHAR(255) NULL DEFAULT NULL,
  `Obligatory/optional` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`Codi`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Temps`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Temps` (
  `TempsId` INT NOT NULL,
  `TempsComplet` DATETIME NULL,
  `Dia` INT NULL,
  `Mes` INT NULL,
  `NomMes` VARCHAR(255) NULL,
  `Trimestre` INT NULL,
  `NumAny` INT NULL,
  `Hora` INT NULL,
  `Minut` INT NULL,
  `DiaSetmana` INT NULL,
  `DescripcioDiaSetmana` VARCHAR(255) NULL,
  PRIMARY KEY (`TempsId`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Accessos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Accessos` (
  `AccesId` INT NOT NULL AUTO_INCREMENT,
  `MemberId` INT NULL,
  `ClubId` VARCHAR(255) NULL,
  `TempsId` INT NULL,
  PRIMARY KEY (`AccesId`),
  CONSTRAINT `TempsFK`
    FOREIGN KEY (`TempsId`)
    REFERENCES `ClubFitnessDW`.`Temps` (`TempsId`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `ClubFK`
    FOREIGN KEY (`ClubId`)
    REFERENCES `ClubFitnessDW`.`Clubs` (`CodiClub`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE INDEX `TempsFK_idx` ON `ClubFitnessDW`.`Accessos` (`TempsId` ASC);

CREATE INDEX `ClubFK_idx` ON `ClubFitnessDW`.`Accessos` (`ClubId` ASC);


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Ingressos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Ingressos` (
  `IngresId` INT NOT NULL AUTO_INCREMENT,
  `MemberId` INT NULL,
  `ClubId` VARCHAR(255) NULL,
  `QuotaId` VARCHAR(255) NULL,
  `TempsId` INT NULL,
  `Quantitat` DECIMAL(5,2) NULL,
  PRIMARY KEY (`IngresId`),
  CONSTRAINT `TempsIdFK`
    FOREIGN KEY (`TempsId`)
    REFERENCES `ClubFitnessDW`.`Temps` (`TempsId`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `QuotaFK`
    FOREIGN KEY (`QuotaId`)
    REFERENCES `ClubFitnessDW`.`Quotes` (`Codi`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE INDEX `TempsIdFK_idx` ON `ClubFitnessDW`.`Ingressos` (`TempsId` ASC);

CREATE INDEX `QuotaFK_idx` ON `ClubFitnessDW`.`Ingressos` (`QuotaId` ASC);


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;




-- -----------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------

-- IMPORTACIO DELS RESPECTIUS ARXIUS CSV A LES TAULES CORRESPONENTS DE LA STAGING AREA

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Clubs.csv" into table cfstagingarea.clubs
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Monthly_fees.csv" into table cfstagingarea.monthly_fees
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Members_ASTU.csv" into table cfstagingarea.members
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Members_BILB.csv" into table cfstagingarea.members
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Members_LVTE.csv" into table cfstagingarea.members
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Members_SEVI.csv" into table cfstagingarea.members
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Members_KOLN.csv" into table cfstagingarea.members
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Members_DENV.csv" into table cfstagingarea.members
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Access_2011.csv" into table cfstagingarea.access
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Access_2012.csv" into table cfstagingarea.access
fields terminated by ';'
lines terminated by '\n';

load data infile "/Users/jvericat/Dropbox/UOC/TFM/Dades i BBDD/CSV import staging area/Access_2013.csv" into table cfstagingarea.access
fields terminated by ';'
lines terminated by '\n';


-- -----------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------

-- Es copia la taula monthly_fees de la Staging Area a la taula quotes del DW
INSERT clubfitnessdw.quotes
SELECT *
FROM cfstagingarea.monthly_fees;

-- S'actualitzen els camps String importats del CSV amb l'string correcte
UPDATE clubfitnessdw.quotes SET codi = 'CHILD' WHERE codi LIKE '%CHILD%';
UPDATE clubfitnessdw.quotes SET codi = 'TEEN' WHERE codi LIKE '%TEEN%';
UPDATE clubfitnessdw.quotes SET codi = 'ADUL' WHERE codi LIKE '%ADUL%';
UPDATE clubfitnessdw.quotes SET codi = 'PENS' WHERE codi LIKE '%PENS%';
UPDATE clubfitnessdw.quotes SET codi = 'TENIS' WHERE codi LIKE '%TENIS%';
UPDATE clubfitnessdw.quotes SET codi = 'PADEL' WHERE codi LIKE '%PADEL%';
UPDATE clubfitnessdw.quotes SET codi = 'PETRA' WHERE codi LIKE '%PETRA%';


-- ------------------------------------------------------------------------------

-- Es copia la taula clubs de la Staging Area a la taula clubs del DW
INSERT clubfitnessdw.clubs
SELECT *
FROM cfstagingarea.clubs;

-- -----------------------------------------------------------------------------


-- Es copien la taula members de la Staging Area a la taula membres del DW (sense els atributs DATE)
INSERT INTO clubfitnessdw.membres (Club_name, Member_number, Member_name, City, Country, Sex, Marital_status, Monthly_tennis_fee, Monthly_padel_fee, Monthly_personal_trainer_fee)
SELECT `members`.`Club_name`, `members`.`Member_number`, `members`.`Member_name`, `members`.`City`, `members`.`Country`, `members`.`Sex`,
 `members`.`Marital_status`, `members`.`Monthly_tennis_fee`, `members`.`Monthly_padel_fee`, `members`.`Monthly_personal_trainer_fee`
FROM cfstagingarea.members;


-- Es copien els atributs de format DATE amb la conversio de VARCHAR a DATE corresponent, i s'assignen els valors dels camps AGE i AGE_GROUP
UPDATE
    clubfitnessdw.membres INNER JOIN cfstagingarea.members
SET
    clubfitnessdw.membres.Registration_data = str_to_date(cfstagingarea.members.Registration_data, '%d/%m/%Y'),
    clubfitnessdw.membres.Birth_date = str_to_date(cfstagingarea.members.Birth_date, '%d/%m/%Y'),
    clubfitnessdw.membres.Age = DATEDIFF(CURDATE(),str_to_date(cfstagingarea.members.Birth_date, '%d/%m/%Y')) DIV 365
    
    WHERE  (clubfitnessdw.membres.Club_name = cfstagingarea.members.Club_name 
      AND clubfitnessdw.membres.Member_number = cfstagingarea.members.Member_number);
      
UPDATE     
	clubfitnessdw.membres
SET  clubfitnessdw.membres.Group_age = IF(Age <= 20, 'Fins a 20 anys', IF((Age > 20 && Age <=30), 'de 21 a 30 anys', 
	IF((Age > 30 && Age <=40), 'de 31 a 40 anys', IF((Age > 40 && Age <=50), 'de 41 a 50 anys',
    IF((Age > 50 && Age <=60), 'de 51 a 60 anys', IF(Age > 60 , 'Majors de 60 anys', NULL))))));
    
UPDATE
    clubfitnessdw.membres INNER JOIN cfstagingarea.members
SET
    clubfitnessdw.membres.Since_when_is_debtor = str_to_date(cfstagingarea.members.Since_when_is_debtor, '%d/%m/%Y')

    WHERE  (clubfitnessdw.membres.Club_name = cfstagingarea.members.Club_name 
      AND clubfitnessdw.membres.Member_number = cfstagingarea.members.Member_number
      AND cfstagingarea.members.Since_when_is_debtor != 'null');
  

-- Es crea una PK autoincrementable a la taula membres per tenir una PrimaryKey unica (no combinada) de cara al cub OLAP
ALTER TABLE clubfitnessdw.membres ADD MembreId INT UNSIGNED NOT NULL AUTO_INCREMENT FIRST,
  ADD PRIMARY KEY (MembreId);

-- ---------------------------------------------------------------------------------------------------------

-- Omplim la taula de Temps amb les dades temporals dels registres d'accessos de la Staging Area
INSERT INTO clubfitnessdw.temps (TempsId, TempsComplet)
    SELECT DISTINCT UNIX_TIMESTAMP(str_to_date(TempsAcces, '%d/%m/%Y %H:%i')), str_to_date(TempsAcces, '%d/%m/%Y %H:%i')
		FROM cfstagingarea.access;

-- S'acaben d'omplir tots els camps de la taula temps a partir de la data completa
UPDATE clubfitnessdw.temps
	SET Dia = DAY(TempsComplet), Mes = MONTH(TempsComplet), NomMes = MONTHNAME(TempsComplet), Trimestre = QUARTER(TempsComplet),
        NumAny = YEAR(TempsComplet), Hora = HOUR(TempsComplet), Minut = MINUTE(TempsComplet), DiaSetmana =DAYOFWEEK(TempsComplet), 
        DescripcioDiaSetmana = DAYNAME(TempsComplet);
			
-- ------------------------------------------------------------------------------------------------------------------------------

-- Es crea una PK autoincrementable a la taula accessos de la Staging Area
ALTER TABLE cfstagingarea.access ADD AccesId INT UNSIGNED NOT NULL AUTO_INCREMENT FIRST,
  ADD PRIMARY KEY (AccesId);
  
-- S'actualitzen els camps String importats del CSV amb l'string correcte
UPDATE cfstagingarea.access SET Club = 'ASTU' WHERE Club LIKE '%ASTU%';
UPDATE cfstagingarea.access SET Club = 'BILB' WHERE Club LIKE '%BILB%';
UPDATE cfstagingarea.access SET Club = 'SEVI' WHERE Club LIKE '%SEVI%';
UPDATE cfstagingarea.access SET Club = 'LVTE' WHERE Club LIKE '%LVTE%';
UPDATE cfstagingarea.access SET Club = 'KOLN' WHERE Club LIKE '%KOLN%';
UPDATE cfstagingarea.access SET Club = 'DENV' WHERE Club LIKE '%DENV%';
       
  
-- S'omple la taula Accessos del DW a partir de les dades de la Staging Area, i li vinculem el TempsId 
-- corresponent de la taula temps del DW
INSERT INTO clubfitnessdw.accessos (MemberId, ClubId, TempsId)
    SELECT (SELECT MembreId from membres where membres.Member_number = cfstagingarea.access.Member_number and membres.Club_name = cfstagingarea.access.Club), 
		Club, UNIX_TIMESTAMP(str_to_date(TempsAcces, '%d/%m/%Y %H:%i'))
			FROM cfstagingarea.access;

-- -----------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------

-- CREACIO PROCEDURE creacio_unitats_calendari()
USE `clubfitnessdw`;
DROP procedure IF EXISTS `creacio_unitats_calendari`;

DELIMITER $$
USE `clubfitnessdw`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `creacio_unitats_calendari`()
BEGIN

	DECLARE i,j int;
    DECLARE tempsString VARCHAR(255);
	SET i = 2010;-- inicialitzem la variable "i"
	loop_label_i: LOOP -- inici del cicle i (loop dels anys)
		SET j = 0;-- inicialitzem la variable "j"
        SET i = i + 1; -- contador i
			IF i = 2014 THEN
				LEAVE loop_label_i; -- informa que acaba el loop dels anys (j)
			END IF;
		loop_label_j: LOOP -- inici del cicle j (loop dels mesos)			
            SET j = j + 1;
			IF j = 13 THEN
				LEAVE loop_label_j; -- informa que acaba el loop dels mesos (i)
			END IF;
			SET tempsString = 'null';
			SET tempsString = CONCAT(CONCAT(CONCAT(CONCAT('01/',LPAD(j,2,'00')),'/'),i),' 00:00');
            INSERT into clubfitnessdw.temps (TempsId, TempsComplet, Mes, NomMes, NumAny) 
              VALUES (UNIX_TIMESTAMP(str_to_date(tempsString, '%d/%m/%Y %H:%i')),str_to_date(tempsString, '%d/%m/%Y %H:%i'),j, MONTHNAME(str_to_date(tempsString, '%d/%m/%Y %H:%i')), i);
		END loop;
	END loop;
    
END$$

DELIMITER ;






-- -----------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------
 
-- CRECIO PROCEDURE omplir_ingressos()

USE `clubfitnessdw`;
DROP procedure IF EXISTS `omplir_ingressos`;

DELIMITER $$
USE `clubfitnessdw`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `omplir_ingressos`()
BEGIN
	DECLARE done1 INT DEFAULT 0;
    DECLARE done2 INT DEFAULT 0;
	DECLARE naixement, debtor, registre DATE;
    DECLARE num_membre, id_temps, edat INT;
    DECLARE temps_c double;
    DECLARE quota_padel, quota_tennis, quota_trainer CHAR(1);
    DECLARE club, codi_quota VARCHAR(255);
    DECLARE preu DECIMAL(5,2);
	
    DECLARE cursor_membres 
		CURSOR FOR SELECT MembreId, Club_name, Registration_data, Birth_date, Monthly_tennis_fee, Monthly_padel_fee, Monthly_personal_trainer_fee, Since_when_is_debtor
			FROM membres;
	
	DECLARE cursor_temps
		CURSOR FOR SELECT TempsId, TempsComplet
			FROM temps
				WHERE Dia IS NULL;

                
	DECLARE CONTINUE HANDLER 
        FOR NOT FOUND SET done1 = 1;   
        
	OPEN cursor_membres;
    
    bucle_membres: LOOP
    
		FETCH cursor_membres 
			INTO  num_membre, club, registre, naixement, quota_tennis, quota_padel, quota_trainer, debtor;
            
            
		-- SELECT club, num_membre, registre, naixement, quota_tennis, quota_padel, quota_trainer, debtor;

		IF done1 = 1 THEN 
			LEAVE bucle_membres;
		END IF;

		-- Insertem les quotes opcionals de padel
        IF quota_tennis = 'Y' THEN
			SET codi_quota = 'TENIS';
            SET preu = (SELECT Price from quotes where Codi = 'TENIS');
			INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
				SELECT num_membre, club, codi_quota, temps.tempsId, preu
					FROM temps 
					WHERE (temps.Dia IS NULL AND temps.TempsComplet > registre AND (temps.TempsComplet < debtor OR debtor IS NULL));
		END IF;
            
		-- Insertem les quotes opcionals de padel
       IF quota_padel = 'Y' THEN
			SET codi_quota = 'PADEL';
            SET preu = (SELECT Price from quotes where Codi = 'PADEL');
			INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
				SELECT num_membre, club, codi_quota, temps.tempsId, preu 
					FROM temps 
					WHERE (temps.Dia IS NULL AND temps.TempsComplet > registre AND (temps.TempsComplet < debtor OR debtor IS NULL));
		END IF;
       
       -- Insertem les quotes opcionals de personal trainer
       IF quota_trainer = 'Y' THEN
			SET codi_quota = 'PETRA';
            SET preu = (SELECT Price from quotes where Codi = 'PETRA');
			INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
				SELECT num_membre, club, codi_quota, temps.tempsId, preu
					FROM temps 
					WHERE (temps.Dia IS NULL AND temps.TempsComplet > registre AND (temps.TempsComplet < debtor OR debtor IS NULL));
		END IF; 
        

        -- Insertem les quotes mensuals obligatories 
		
        block2: BEGIN
        
        
		DECLARE CONTINUE HANDLER 
			FOR NOT FOUND SET done2 = 1; 
        
        
		open cursor_temps;
        
        bucle_temps: LOOP
        
			SET done2 = 0;
        
			FETCH cursor_temps
				INTO id_temps, temps_c;
            
			IF done2 = 1 THEN 
			LEAVE bucle_temps;
            END IF;
			
            
            SET edat = DATEDIFF(DATE(temps_c),naixement) DIV 365;
            
            IF edat<12 THEN SET codi_quota = 'CHILD';
			ELSEIF (12<=edat AND edat< 18) THEN SET codi_quota = 'TEEN';
			ELSEIF (18<=edat AND edat< 65) THEN SET codi_quota = 'ADUL';
			ELSE  SET codi_quota = 'PENS';
            END IF;
            
            IF (DATE(temps_c) > registre AND (DATE(temps_c) < debtor OR debtor IS NULL))
			THEN 
				SET preu = (SELECT Price from quotes where codi_quota = Codi);
                INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
					SELECT  num_membre, club, codi_quota, id_temps, preu;
			END IF;
					
            
        END LOOP bucle_temps;
        

        END block2;
        
	CLOSE cursor_temps; 
        
	END LOOP bucle_membres;
 
	CLOSE cursor_membres;

END$$

DELIMITER ;


-- -----------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------

-- Crida del procediment que crea els registres mensuals de la taula de temps per analitzar 'ingressos' i 'accessos'
call clubfitnessdw.creacio_unitats_calendari();

-- Crida del procediment que omple la taula de fets ingressos amb els càlculs pertinents
call clubfitnessdw.omplir_ingressos();


-- -----------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------
