-- MySQL Script generated by MySQL Workbench
-- 01/02/15 14:46:43
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema CFStagingArea
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `CFStagingArea` ;

-- -----------------------------------------------------
-- Schema CFStagingArea
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `CFStagingArea` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;
-- -----------------------------------------------------
-- Schema ClubFitnessDW
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `ClubFitnessDW` ;

-- -----------------------------------------------------
-- Schema ClubFitnessDW
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `ClubFitnessDW` ;
USE `CFStagingArea` ;

-- -----------------------------------------------------
-- Table `CFStagingArea`.`Clubs`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Clubs` (
  `CodiClub` VARCHAR(255) NOT NULL,
  `ClubName` VARCHAR(255) NULL DEFAULT NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`CodiClub`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE UNIQUE INDEX `CodiClub_UNIQUE` ON `CFStagingArea`.`Clubs` (`CodiClub` ASC);


-- -----------------------------------------------------
-- Table `CFStagingArea`.`Members`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Members` (
  `Club_name` VARCHAR(255) NOT NULL,
  `Member_number` INT NOT NULL,
  `Member_name` VARCHAR(255) NULL DEFAULT NULL,
  `Profession` VARCHAR(255) NULL,
  `Address` VARCHAR(255) NULL,
  `City` VARCHAR(255) NULL DEFAULT NULL,
  `Region` VARCHAR(255) NULL,
  `PostalCode` VARCHAR(255) NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  `Phone` VARCHAR(255) NULL,
  `Fax` VARCHAR(255) NULL,
  `Registration_data` VARCHAR(255) NULL DEFAULT NULL,
  `Sex` CHAR(1) NULL DEFAULT NULL,
  `Marital_status` VARCHAR(255) NULL DEFAULT NULL,
  `Birth_date` VARCHAR(255) NULL DEFAULT NULL,
  `Monthly_tennis_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_padel_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_personal_trainer_fee` CHAR(1) NULL DEFAULT NULL,
  `Since_when_is_debtor` VARCHAR(255) NULL DEFAULT NULL,
  `Registration_web` CHAR(1) NULL,
  PRIMARY KEY (`Club_name`, `Member_number`),
  CONSTRAINT `Club_name`
    FOREIGN KEY (`Club_name`)
    REFERENCES `CFStagingArea`.`Clubs` (`CodiClub`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE INDEX `Club_name_idx` ON `CFStagingArea`.`Members` (`Club_name` ASC);


-- -----------------------------------------------------
-- Table `CFStagingArea`.`Monthly_fees`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Monthly_fees` (
  `Code` VARCHAR(255) NOT NULL,
  `Description` VARCHAR(255) NULL DEFAULT NULL,
  `Price` DECIMAL(5,2) NULL DEFAULT NULL,
  `Fee_type` VARCHAR(255) NULL DEFAULT NULL,
  `Obligatory/optional` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`Code`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `CFStagingArea`.`Access`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `CFStagingArea`.`Access` (
  `TempsAcces` VARCHAR(255) NULL,
  `Member_number` INT NULL,
  `Club` VARCHAR(255) NULL)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

USE `ClubFitnessDW` ;

-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Clubs`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Clubs` (
  `CodiClub` VARCHAR(255) NOT NULL,
  `ClubName` VARCHAR(255) NULL DEFAULT NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`CodiClub`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Membres`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Membres` (
  `Club_name` VARCHAR(255) NULL,
  `Member_number` INT NULL,
  `Member_name` VARCHAR(255) NULL DEFAULT NULL,
  `City` VARCHAR(255) NULL DEFAULT NULL,
  `Country` VARCHAR(255) NULL DEFAULT NULL,
  `Registration_data` DATE NULL DEFAULT NULL,
  `Sex` CHAR(1) NULL DEFAULT NULL,
  `Marital_status` VARCHAR(255) NULL DEFAULT NULL,
  `Birth_date` DATE NULL DEFAULT NULL,
  `Age` INT NULL,
  `Group_age` VARCHAR(255) NULL DEFAULT NULL,
  `Monthly_tennis_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_padel_fee` CHAR(1) NULL DEFAULT NULL,
  `Monthly_personal_trainer_fee` CHAR(1) NULL DEFAULT NULL,
  `Since_when_is_debtor` DATE NULL DEFAULT NULL,
  CONSTRAINT `Club_FK`
    FOREIGN KEY (`Club_name`)
    REFERENCES `ClubFitnessDW`.`Clubs` (`CodiClub`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Quotes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Quotes` (
  `Codi` VARCHAR(255) NOT NULL,
  `Description` VARCHAR(255) NULL,
  `Price` DECIMAL(5,2) NULL DEFAULT NULL,
  `Fee_type` VARCHAR(255) NULL DEFAULT NULL,
  `Obligatory/optional` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY (`Codi`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Temps`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Temps` (
  `TempsId` INT NOT NULL,
  `TempsComplet` DATETIME NULL,
  `Dia` INT NULL,
  `Mes` INT NULL,
  `NomMes` VARCHAR(255) NULL,
  `Trimestre` INT NULL,
  `NumAny` INT NULL,
  `Hora` INT NULL,
  `Minut` INT NULL,
  `DiaSetmana` INT NULL,
  `DescripcioDiaSetmana` VARCHAR(255) NULL,
  PRIMARY KEY (`TempsId`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Accessos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Accessos` (
  `AccesId` INT NOT NULL AUTO_INCREMENT,
  `MemberId` INT NULL,
  `ClubId` VARCHAR(255) NULL,
  `TempsId` INT NULL,
  PRIMARY KEY (`AccesId`),
  CONSTRAINT `TempsFK`
    FOREIGN KEY (`TempsId`)
    REFERENCES `ClubFitnessDW`.`Temps` (`TempsId`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `ClubFK`
    FOREIGN KEY (`ClubId`)
    REFERENCES `ClubFitnessDW`.`Clubs` (`CodiClub`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE INDEX `TempsFK_idx` ON `ClubFitnessDW`.`Accessos` (`TempsId` ASC);

CREATE INDEX `ClubFK_idx` ON `ClubFitnessDW`.`Accessos` (`ClubId` ASC);


-- -----------------------------------------------------
-- Table `ClubFitnessDW`.`Ingressos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ClubFitnessDW`.`Ingressos` (
  `IngresId` INT NOT NULL AUTO_INCREMENT,
  `MemberId` INT NULL,
  `ClubId` VARCHAR(255) NULL,
  `QuotaId` VARCHAR(255) NULL,
  `TempsId` INT NULL,
  `Quantitat` DECIMAL(5,2) NULL,
  PRIMARY KEY (`IngresId`),
  CONSTRAINT `TempsIdFK`
    FOREIGN KEY (`TempsId`)
    REFERENCES `ClubFitnessDW`.`Temps` (`TempsId`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `QuotaFK`
    FOREIGN KEY (`QuotaId`)
    REFERENCES `ClubFitnessDW`.`Quotes` (`Codi`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE INDEX `TempsIdFK_idx` ON `ClubFitnessDW`.`Ingressos` (`TempsId` ASC);

CREATE INDEX `QuotaFK_idx` ON `ClubFitnessDW`.`Ingressos` (`QuotaId` ASC);


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
